package com.tzld.piaoquan.recommend.server.dataloader;

import com.aliyun.odps.Instance;
import com.aliyun.odps.Odps;
import com.aliyun.odps.OdpsException;
import com.aliyun.odps.account.Account;
import com.aliyun.odps.account.AliyunAccount;
import com.aliyun.odps.data.Record;
import com.aliyun.odps.task.SQLTask;
import com.aliyun.odps.tunnel.io.TunnelRecordReader;
import com.google.common.collect.ListMultimap;
import com.tzld.piaoquan.recommend.server.common.base.*;
import com.tzld.piaoquan.recommend.server.dataloader.OfflineSamplesLoader;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;



class Task implements Runnable {
    // 使用list避免线程队列增长无限制，所以采用10万条内容提交一次线程
    private List<String> keys;
    public Task(List<String> keys){
        this.keys = keys;
    }
    public void run() {
     //TODO write List<String> to Redis
    }
}


public class FeatureToRedisLoader {

    private static final ExecutorService persistOnlineFeaturesExecutor = Executors.newFixedThreadPool(10);

    public static void loadFeatureToRedis(String userTable, String dt) {
        TunnelRecordReader reader = FeatureConstructor.loadDataFromOSSSession(userTable, dt);
        Record record;
        ArrayList<String> keyList = new ArrayList<>();
        int count = 0;
        try {
            while ((record = reader.read()) != null) {
                UserFeature userFeature = FeatureConstructor.constructUserFeature(record);
                // TODO add string format for redis
                String tmp =  userFeature.parsetoRedisString();
                keyList.add(tmp);
                if(count < 100000) {
                    count++;
                } else if (count == 100000) {
                    persistOnlineFeaturesExecutor.execute(new Task(keyList));
                    keyList = new ArrayList<>();
                    count = 0;
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    public static void main(String[] args) {
        String Path = "";

    }

}
